/************************************************************************\
 *																		*
 *	File name:		kill.cpp											*
 *	Project:		kill												*
 *																		*
 *	Author:			Mattias Goethe										*
 *	Date:			2001-04-05											*
 *	Version:		1.000.2												*
 *	Platform:		Windows98, should build on any Win32				*
 *																		*
 *																		*
 *	Abstract:		Utility to terminate faulty processes				*
 *																		*
 *					Released in the public domain. This file			*
 *					may be used, modified, compiled or sold				*
 *					for any purpose what so ever.						*
 *																		*
\************************************************************************/
#include <windows.h>
#include <conio.h>
#include <stdio.h>
#include <tlhelp32.h>

typedef enum
{
	CMD_LIST_PROCESSES,
	CMD_KILL_PROCESS
}COMMAND;

typedef struct _PROGRAM_DATA
{
	COMMAND cmd;
	BOOL silent;
	BOOL suspenders;
	char* filename;
	UINT exit_code;
}PROGRAM_DATA;

int exec_cmd(PROGRAM_DATA* ppd)
{
	HANDLE hSnapshot;
	HANDLE hProcess;
	PROCESSENTRY32 pe;
	BOOL found_it = FALSE;
	char filename[256];
	char extension[256];
	int rslt = 0;

	/* get an image of all processes in system */
	hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if(!hSnapshot){
		printf("Error: Failed creating snapshot\nterminating.\n");
		return -1;
	}

	ZeroMemory(&pe, sizeof(PROCESSENTRY32));
	pe.dwSize = sizeof(PROCESSENTRY32);

	/* iterate through all processes */
	if(Process32First(hSnapshot, &pe)){
		do{
			_splitpath(pe.szExeFile, NULL, NULL, filename, extension);
			strcat(filename, extension);
			if(ppd->cmd == CMD_LIST_PROCESSES){
				printf("%s\n", filename);
			}
			else if(ppd->cmd == CMD_KILL_PROCESS){
				if(stricmp(filename, ppd->filename) == 0){
					found_it = TRUE;
					hProcess = OpenProcess(
						PROCESS_ALL_ACCESS, 
						FALSE, pe.th32ProcessID);
					if(!hProcess){
						printf("Error: Failed to access process %08x\n",
							pe.th32ProcessID); 
						rslt = -2;
						break;
					}
					else{
						if(ppd->suspenders){
							int usr;
							/* ask user if the process really 
							   should be terminated */
							printf("About to kill process %08x (%s)\n"
								"Continue (Y/N)?\n", pe.th32ProcessID, 
								ppd->filename);
							usr = getch();
							if(tolower(usr) != 'y')
								break;

						}
						if(!ppd->silent)
							printf("Terminating process %08x.\n",
							pe.th32ProcessID);
						if(!TerminateProcess(hProcess, ppd->exit_code)){
							printf(".\nError: "
								"Failed to terminate process %08x\n",
								pe.th32ProcessID); 
							rslt = -2;
						}
						else{
							if(!ppd->silent)
								printf("Done.\n");
						}
						break;
					}
				}
			}
		}while(Process32Next(hSnapshot, &pe));
	}

	if((ppd->cmd == CMD_KILL_PROCESS)&&(found_it == FALSE)){
		printf("Error: No such module (%s)\n",ppd->filename); 
		rslt = -3;
	}

	CloseHandle(hSnapshot);
	return rslt;
}

void show_usage()
{
	printf("Kill by Fuck Station Zero Software\n");
	printf("version 1.000.2 (" __DATE__ ")\n");
	printf("Usage:\n\n");
	printf("kill [program] [-v] [-s] [-xN] [-?]\n\n");
	printf("where \"program\" is the program to close\n\n");
	printf("Switches:\n");
	printf("-n\tno questions asked\n");
	printf("-s\tsilent mode (implies -n)\n");
	printf("-xN\tN is exit code of process\n");
	printf("-?\tthis screen\n");
}

int main(int argc, char* argv[])
{
	char* cp;
	int i;
	PROGRAM_DATA pd;
	int rslt;

	pd.silent = FALSE;
	pd.suspenders = TRUE;
	pd.cmd = CMD_LIST_PROCESSES;
	pd.exit_code = 0;

	rslt = 0;

	/* find out what the user wants us to do */
	for(i = 1; i < argc; i++){
		cp = argv[i];
		while(*cp){
			switch(*cp){
			/* read the switches */
			case '/':
			case '-':
				cp++;
				switch(*cp){
				case 'n':
					pd.suspenders = FALSE;
					break;
				case 's':
					pd.silent = TRUE;
					pd.suspenders = FALSE;
					break;
				case 'x':
					cp++;
					pd.exit_code = strtoul(cp, &cp, 10);
					cp--;
					break;
				default:
					printf("Unknown switch: %s\n", argv[i]);
					show_usage();
					return -1;
				case '?':
					show_usage();
					return 0;
					break;
				}
				break;
			/* otherwise, we assume its a filename */
			default:
				pd.filename = cp;
				pd.cmd = CMD_KILL_PROCESS;
				cp += strlen(cp) - 1;
				break;
			};
			cp++;
		};
	}

	/* do it */
	rslt = exec_cmd(&pd);
	return rslt;
}

